#include <iostream>
//#include <windows.h>  // For MS Windows

//GLUT, includes glu.h and gl.h
#include <GL/freeglut.h>


using namespace std;


/* Handler for window-repaint event. Call back when the window first appears and
   whenever the window needs to be re-painted. */
void display() {
   glClearColor(0.0f, 0.0f, 0.0f, 1.0f); // Set background color to black and opaque

   // Clear the color buffer, it takes 1 argument which indicates which buffer is to be cleared. In this case color buffer
   glClear(GL_COLOR_BUFFER_BIT);   
 
   // Draw a Red 1x1 Square centered at origin
   glBegin(GL_QUADS);              // Each set of 4 vertices form a quad
      glColor3f(1.0f, 0.0f, 0.0f); // Red
      glVertex2f(-0.5f, -0.5f);    // x, y
      glVertex2f( 0.5f, -0.5f);
      glVertex2f( 0.5f,  0.5f);
      glVertex2f(-0.5f,  0.5f);
   glEnd();

   glBegin(GL_TRIANGLES);              // Each set of 3 vertices form a triangle
      glColor3f(0.0f, 1.0f, 0.0f); // green
      glVertex2f(-0.8f, -0.8f);    // x, y
      glVertex2f( 0.5f, -0.5f);
      glVertex2f( 0.5f,  0.5f);
   glEnd();
   
   glFlush();   // Render now
}


// callback event handler - event je re-paint (poziva se kada se prvi put prikaze prozor, kada se smanji, poveca..)
// poziva je sistem, ne nas program
void display1() {

    glClearColor(1.0f, 1.0f, 1.0f, 1.0f); // Set background color to white and opaque

   // Clear the color buffer, it takes 1 argument which indicates which buffer is to be cleared. In this case color buffer
   glClear(GL_COLOR_BUFFER_BIT);   
 

   // Define shapes enclosed within a pair of glBegin and glEnd
   glBegin(GL_QUADS);              // Each set of 4 vertices form a quad
      glColor3f(1.0f, 0.0f, 0.0f); // Red
      glVertex2f(-0.8f, 0.1f);     // Define vertices in counter-clockwise (CCW) order
      glVertex2f(-0.2f, 0.1f);     //  so that the normal (front-face) is facing you
      glVertex2f(-0.2f, 0.7f);
      glVertex2f(-0.8f, 0.7f);
 
      glColor3f(0.0f, 1.0f, 0.0f); // Green
      glVertex2f(-0.7f, -0.6f);
      glVertex2f(-0.1f, -0.6f);
      glVertex2f(-0.1f,  0.0f);
      glVertex2f(-0.7f,  0.0f);
 
      glColor3f(0.2f, 0.2f, 0.2f); // Dark Gray
      glVertex2f(-0.9f, -0.7f);
      glColor3f(1.0f, 1.0f, 1.0f); // White
      glVertex2f(-0.5f, -0.7f);
      glColor3f(0.2f, 0.2f, 0.2f); // Dark Gray
      glVertex2f(-0.5f, -0.3f);
      glColor3f(1.0f, 1.0f, 1.0f); // White
      glVertex2f(-0.9f, -0.3f);
   glEnd();
 
   glBegin(GL_TRIANGLES);          // Each set of 3 vertices form a triangle
      glColor3f(0.0f, 0.0f, 1.0f); // Blue
      glVertex2f(0.1f, -0.6f);
      glVertex2f(0.7f, -0.6f);
      glVertex2f(0.4f, -0.1f);
 
      glColor3f(1.0f, 0.0f, 0.0f); // Red
      glVertex2f(0.3f, -0.4f);
      glColor3f(0.0f, 1.0f, 0.0f); // Green
      glVertex2f(0.9f, -0.4f);
      glColor3f(0.0f, 0.0f, 1.0f); // Blue
      glVertex2f(0.6f, -0.9f);
   glEnd();
 
   glBegin(GL_POLYGON);            // These vertices form a closed polygon
      glColor3f(1.0f, 1.0f, 0.0f); // Yellow
      glVertex2f(0.4f, 0.2f);
      glVertex2f(0.6f, 0.2f);
      glVertex2f(0.7f, 0.4f);
      glVertex2f(0.6f, 0.6f);
      glVertex2f(0.4f, 0.6f);
      glVertex2f(0.3f, 0.4f);
   glEnd();
 
   glFlush();  // Render now
}


/* Handler for window re-size event. Called back when the window first appears and
   whenever the window is re-sized with its new width and height */
void reshape(GLsizei width, GLsizei height) {  // GLsizei for non-negative integer
   // Compute aspect ratio of the new window
   if (height == 0) height = 1;                // To prevent divide by 0
   GLfloat aspect = (GLfloat)width / (GLfloat)height;
 
   // Set the viewport to cover the new window
   glViewport(0, 0, width, height);
 
   // Set the aspect ratio of the clipping area to match the viewport
   glMatrixMode(GL_PROJECTION);  // To operate on the Projection matrix
   glLoadIdentity();             // Reset the projection matrix
   if (width >= height) {
      // aspect >= 1, set the height from -1 to 1, with larger width
      gluOrtho2D(-1.0 * aspect, 1.0 * aspect, -1.0, 1.0);
   } else {
      // aspect < 1, set the width to -1 to 1, with larger height
      gluOrtho2D(-1.0, 1.0, -1.0 / aspect, 1.0 / aspect);
   }
}


int main(int argc, char** argv)
{    
   // GLUT omogucava apstraktne funkcionalnosti kao sto je crtanje prozora, interakcija sa korisnikom, uopste komunikacija sa OS
   // dok je grafika nizeg nivoa u GL modulu

   // Poziva se PRIJE svih GLUT funkcija, uzima argumente kao main
   glutInit(&argc, argv);                 // Initialize GLUT
   glutCreateWindow("Prvi OpenGL prozor"); // Create a window with the given title
   glutInitWindowSize(320, 320);   // Set the window's initial width & height in pixels

   glutInitWindowPosition(50, 50); // Position the window's initial top-left corner (pozicija 0,0 je u gornjem lijevom uglu ekrana)

   glutDisplayFunc(display2); // Register display callback handler for window re-paint
      
   glutReshapeFunc(reshape);       // Register callback handler for window re-size event

   // Set "clearing" or background color
   //glClearColor(0.0f, 0.0f, 0.0f, 1.0f); // Black and opaque

   glutMainLoop();           // Enter the infinitely event-processing loop - 
   // od ovog trenutka OpenGL sistem ulazi u beskonacnu petlju cekanja i obrade eventa (kao re-paint) pomocu callback event handlera (kao sto je display1)
   

   return 1;
}
